include \masm32\include\masm32rt.inc

MyTest	PROTO: DWORD, :DWORD, :DWORD

SeqTest MACRO JmpCondition, TheProc, TheArgs:VARARG
LOCAL TheInvoke
  ifndef SeqNum
	SeqNum = 0
  endif
  ifb <TheArgs>
	call TheProc
  else
	TheInvoke equ <invoke TheProc>
	For arg, <TheArgs>
		TheInvoke CATSTR TheInvoke, <, >, reparg(<arg>)
	ENDM
	% echo TheInvoke
	TheInvoke
  endif
  cmp eax, JmpCondition
  @CatStr(<je SeqTestLbl>, %SeqNum)
ENDM

SeqEnd MACRO
  @CatStr(<SeqTestLbl>, %SeqNum, <:>)
  SeqNum = SeqNum + 1
ENDM

.code
start:	; Cancel a series of tests if eax is IDNO etc.:
	SeqTest IDNO, MyTest, "Click Yes to continue", "A test", MB_YESNO
	SeqTest IDCANCEL, MyTest, "Click OK", "Another test", MB_OKCANCEL
	SeqTest IDYES, MyTest, "Don't click Yes", "And the last one", MB_YESNOCANCEL
	MsgBox 0, "Congrats, you passed the first series!", "Hi", MB_OK
	SeqEnd

	SeqTest IDNO, MyTest, "Click Yes to continue", "Second series of tests", MB_YESNO
	SeqTest IDCANCEL, MyTest, "Click OK", "Another test", MB_OKCANCEL
	SeqTest IDYES, MyTest, "Don't click Yes", "And the last one", MB_YESNOCANCEL
	MsgBox 0, "Congrats, you passed the second series!", "Hi", MB_OK
	SeqEnd

	exit

MyTest proc arg1, arg2, arg3
	MsgBox 0, arg1, arg2, arg3
	ret
MyTest endp

end start
